﻿using UnityEngine;
using System.Collections;

public class PlayerControl : MonoBehaviour {

	public float sensitivity;
	public GameObject bullet;
	private int maxHeath =20;

	public int speedLVL=1;
	public int dmgLVL=1;
	public int frLVL = 1;

	private int rotation;
	private int heath;

	private float fireTime=0;
	private float fireDelay = 1;
	private float dnaTime=0;
	private float dnaDelay = 0.1f;

	// Use this for initialization
	void Start () {
		fireTime = fireDelay/frLVL;
	}

	public void reset(){
		speedLVL=1;
		dmgLVL=1;
		frLVL = 1;
		transform.position = new Vector3 (0,0,0);
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if (GM.playerEnabled) {
						fireTime += Time.deltaTime;
						dnaTime += Time.deltaTime;
						//CharacterController move = (CharacterController)GetComponent ("CharacterController");
						float mx = Input.GetAxis ("ud") * sensitivity * Time.deltaTime;
						float mz = Input.GetAxis ("lr") * sensitivity * Time.deltaTime;
						if (mx != 0 && mz != 0) {
								mx /= 2f;
								mz /= 2f;
						}
						if (mx > 0 && transform.position.x > 38)
								mx = 0;
						if (mx < 0 && transform.position.x < -38)
								mx = 0;
						if (mz > 0 && transform.position.z > 23)
								mz = 0;
						if (mz < 0 && transform.position.z < -23)
								mz = 0;
						transform.Translate (new Vector3 (mx * ((float)speedLVL / 8f), 0, 0));
						transform.Translate (new Vector3 (0, 0, mz * ((float)speedLVL / 8f)));
						transform.position = new Vector3 (transform.position.x, 0, transform.position.z);

						if (Input.GetAxis ("fire") > 0 && fireTime > fireDelay / (frLVL)) {
								fireTime = 0;
								rotation = (int)(Mathf.Atan2 ((Input.mousePosition.y - scaleWorldYToScreenY (transform.position.z)), (Input.mousePosition.x - scaleWorldXToScreenX (transform.position.x))) * -Mathf.Rad2Deg);
								GameObject IBullet = (GameObject)Instantiate (bullet);
								IBullet.SendMessage ("makeDestructible");
								IBullet.transform.position = transform.position;
								IBullet.transform.Rotate (0, rotation, 0);
								IBullet.SendMessage ("setDamage", 0 + (dmgLVL * 5));
								IBullet.rigidbody.AddRelativeForce (new Vector3 (400, 0, 0));
						}
						//if(Input.GetButtonDown("pause")){
						//	GUIManager.setScreen(new DeathScreen());
						//}
						if (GM.dna > 3 && Input.GetButtonDown("evolve")) {
								GUIManager.setPaused (true, new EvolveScreen (this));
						}
						GM.maxPlayerHeath = maxHeath;
				}
	}

	void OnTriggerEnter(Collider col){
		if(col.tag=="dna"){
			Destroy (col.gameObject);
			if(dnaTime>dnaDelay){

				GM.dna++;
				dnaTime = 0;
			}
		}
	}

	void damage(int amt){
		heath -= amt;
		GM.playerHeath = heath;
	}

	int scaleWorldXToScreenX(float worldX){
		float scale = (float)Screen.width / 82f;
		worldX += 41f;
		return (int)(worldX * scale);
	}

	int scaleWorldYToScreenY(float worldY){
		float scale = (float)Screen.height / 46f;
		worldY += 23f;
		return (int)(worldY * scale);
	}
}
