﻿
using UnityEngine;
using System.Collections;

public class RPBControl : MonoBehaviour {

	public Material heathyM;
	public Material infectedM;
	public float xVMax;
	public float zVMax;

	private float xV;
	private float yV;
	private int changeDirTime;
	private float timeCount;

	private bool infected;

	// Use this for initialization
	void Start () {
		renderer.material = heathyM;
	}

	void FixedUpdate(){
		timeCount += Time.deltaTime;
		if (timeCount > changeDirTime) {
			changeDirTime = (int)(Random.value+60);
			timeCount = 0;
			yV+=((Random.value*2.0f) - 1f);
			xV+=((Random.value*2.0f) - 1f);

		}
		//GetComponent ();
		if (transform.position.x > 38 || transform.position.x < -38) {
			xV = -xV;
		}
		if (transform.position.z > 23 || transform.position.z < -23) {
			yV = -yV;
		}

		if (xV > xVMax)xV = xVMax;
		if (xV < -xVMax)xV = -xVMax;
		if (yV > zVMax)yV = zVMax;
		if (yV < -zVMax)yV = zVMax;
		transform.Translate (xV*Time.deltaTime, 0, yV*Time.deltaTime);
		//transform.Translate (0.1f, 0, 0.1f);
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.tag == "wall") {
			xV = -xV;
			yV = -yV;
		}
	}

	public void infect(){
		if (!infected) {
			renderer.material = infectedM;
			infected = true;
			if(transform.parent!=null)
			transform.parent.gameObject.SendMessage("infect");
			GetComponent<BoxCollider>().enabled = false;
		}
	}

}
